// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#include <stdlib.h>
#include <math.h>
#include "escwyp_line_draw.h"


void draw_cross(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // # //
    thepts[0] = 0.3;
    thepts[1] = 0.85;
    thepts[2] = 0.4;
    thepts[3] = 0.15;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.85;
    thepts[2] = 0.7;
    thepts[3] = 0.15;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.6;
    thepts[2] = 0.9;
    thepts[3] = 0.5;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}

void draw_c(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // C //
    thepts[0] = 0.4;
    thepts[1] = 0.85;
    thepts[2] = 0.1;
    thepts[3] = 0.95;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.95;
    thepts[2] = 0.2;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.45;
    thepts[3] = 0.1;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}

void draw_d(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // D //
    thepts[0] = 0.3;
    thepts[1] = 0.2;
    thepts[2] = 0.2;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.2;
    thepts[2] = 0.5;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.1;
    thepts[2] = 0.4;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.4;
    thepts[1] = 0.8;
    thepts[2] = 0.1;
    thepts[3] = 0.9;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_e(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // E //
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.1;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.5;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.5;
    thepts[2] = 0.4;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.9;
    thepts[2] = 0.4;
    thepts[3] = 0.8;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_f(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // F //
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.1;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.5;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.5;
    thepts[2] = 0.4;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_g(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // G //
    thepts[0] = 0.3;
    thepts[1] = 0.5;
    thepts[2] = 0.5;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.4;
    thepts[2] = 0.4;
    thepts[3] = 0.85;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.4;
    thepts[1] = 0.85;
    thepts[2] = 0.1;
    thepts[3] = 0.95;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.1;
    thepts[1] = 0.95;
    thepts[2] = 0.2;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.45;
    thepts[3] = 0.1;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_a(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // A //
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.1;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.5;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.1;
    thepts[2] = 0.4;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.5;
    thepts[2] = 0.4;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_h(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // H //
    thepts[0] = 0.2;
    thepts[1] = 0.2;
    thepts[2] = 0.1;
    thepts[3] = 0.9;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.5;
    thepts[1] = 0.1;
    thepts[2] = 0.4;
    thepts[3] = 0.8;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.2;
    thepts[1] = 0.5;
    thepts[2] = 0.4;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////

}
void draw_b(int *gpoints, const int width, const int height)
{


}

void draw_0(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 0 ZERO //
    thepts[0] = 0.7;
    thepts[1] = 0.1;
    thepts[2] = 0.6;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.5;
    thepts[2] = 0.85;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.85;
    thepts[1] = 0.4;
    thepts[2] = 0.95;
    thepts[3] = 0.05;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.95;
    thepts[1] = 0.05;
    thepts[2] = 0.7;
    thepts[3] = 0.1;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}
void draw_1(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 1 //
    thepts[0] = 0.7;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.7;
    thepts[3] = 0.5;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}
void draw_2(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 2 //
    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.8;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.8;
    thepts[1] = 0.3;
    thepts[2] = 0.6;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.5;
    thepts[2] = 0.9;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}
void draw_3(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 3 //
    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.8;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.8;
    thepts[1] = 0.5;
    thepts[2] = 0.6;
    thepts[3] = 0.6;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.8;
    thepts[1] = 0.3;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}
void draw_4(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 4 //
    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.6;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.6;
    thepts[1] = 0.5;
    thepts[2] = 0.9;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.8;
    thepts[3] = 0.6;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}
void draw_5(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 5 //
    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.7;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.5;
    thepts[2] = 0.7;
    thepts[3] = 0.6;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}
void draw_6(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 6 //
    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.7;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.5;
    thepts[2] = 0.7;
    thepts[3] = 0.6;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.6;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}
void draw_7(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 7 //
    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.75;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.8;
    thepts[3] = 0.5;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}
void draw_8(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 8 //
    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.7;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.5;
    thepts[2] = 0.7;
    thepts[3] = 0.6;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.6;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);
    ////////
}
void draw_9(int *gpoints, const int width, const int height)
{

    float thepts[4];
    // 9 //
    thepts[0] = 0.9;
    thepts[1] = 0.1;
    thepts[2] = 0.7;
    thepts[3] = 0.2;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.2;
    thepts[2] = 0.7;
    thepts[3] = 0.4;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.7;
    thepts[1] = 0.4;
    thepts[2] = 0.9;
    thepts[3] = 0.3;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.5;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.5;
    thepts[2] = 0.7;
    thepts[3] = 0.6;
    draw_lines(0, gpoints, thepts, width, height, 0, 0, 0);

    thepts[0] = 0.9;
    thepts[1] = 0.3;
    thepts[2] = 0.9;
    thepts[3] = 0.1;
    draw_lines(1, gpoints, thepts, width, height, 0, 0, 0);

    ////////
}

void fill_pixels(int *pixels, const int *gpoints, const int width, const int height, const int fg_argb_color, const int bg_argb_color)
{
    int i;
    for(i = height-1; i >= 0; --i){
        int j;
        for(j = 0; j < width; ++j){
            if(gpoints[i*width+j] == 1){
		    pixels[i*width+j] = fg_argb_color;
            }else{
		    pixels[i*width+j] = bg_argb_color;
	    }
        }
    }

}

void change_pixels(int *pixels, const int width, const int height, const int fg_argb_color_from, const int fg_argb_color_to, const int bg_argb_color_from, const int bg_argb_color_to)
{

	int i;
	for(i = height-1; i >= 0; --i){
		int j;
		for(j = 0; j < width; ++j){
			if(pixels[i*width+j] == fg_argb_color_from){
				pixels[i*width+j] = fg_argb_color_to;
			}else{
				if(pixels[i*width+j] == bg_argb_color_from){
					pixels[i*width+j] = bg_argb_color_to;
				}
			}
		}
	}

}

void draw_lines(const int drawit, int *gpoints, const float *raw_points, const int width, const int height, const int stroke_width, const int xpos, const int ypos)
{

	int start_x = (int) roundf(raw_points[0]*(width-1))+xpos;
	int start_y = (int) roundf(raw_points[1]*(height-1))+ypos;
	int end_x = (int) roundf(raw_points[2]*(width-1))+xpos;
	int end_y = (int) roundf(raw_points[3]*(height-1))+ypos;

	int xdiff = end_x - start_x;
	int ydiff = end_y - start_y;
	int xdiffl = 1;
	int ydiffl = 1;
	int xsign = 1;
	int ysign = 1;
	if(xdiff > 0){
		xsign = 1;
		xdiffl = xdiff;
	}else{
		xsign = -1;
		xdiffl = -xdiff;
	}
	if(ydiff > 0){
		ysign = 1;
		ydiffl = ydiff;
	}else{
		ysign = -1;
		ydiffl = -ydiff;
	}

	int num_points = 0; //excluding first point which is handled separately
	int x_is_longer = 0;
	float xfact = 1.0;
	float yfact = 1.0;

	if(xdiffl > ydiffl){
		x_is_longer = 1;
		num_points = xdiffl;
		xfact = xsign*1.0;
		if(xdiffl > 0){
			yfact = (float) ysign*ydiffl/xdiffl;
		}
	}else{
		num_points = ydiffl;
		yfact = ysign*1.0;
		if(ydiffl > 0){
			xfact = (float) xsign*xdiffl/ydiffl;
		}
	}
	//fprintf(stdout, "xdiff = %i, xdiffl = %i, xsign = %i\n", xdiff, xdiffl, xsign);
	//fprintf(stdout, "ydiff = %i, ydiffl = %i, ysign = %i\n", ydiff, ydiffl, ysign);
	//fprintf(stdout, "num_points = %i\n", num_points);
		
	int *points = (int *) malloc((2+2*num_points)*sizeof(int)); //excluding first point which is handled separately
	int counter = 0;
	int i;
	
	points[0] = start_x;
	points[1] = start_y;
	gpoints[points[1]*width+points[0]] = 1;
	//fprintf(stdout, "%i = %i/%i\n", counter, start_x, start_y);
	counter++;
	for(i = 2; i < 2+2*num_points; i+=2){
		points[i] = (int) roundf(start_x + counter*xfact);
		points[i+1] = (int) roundf(start_y + counter*yfact);
		gpoints[points[i+1]*width+points[i]] = 1;
		//gpoints[counter] = 1;
	
		//fprintf(stdout, "%i = %i/%i\n", counter, points[i], points[i+1]);
		counter++;
	}				
	
	//int *zw2 = (int *) malloc(width*sizeof(int));
	//counter = 0;	
	//for(i = 0; i < width; ++i){
	//	if(i < 10){
	//		fprintf(stdout, "%i ", i);
	//	}
	//	if(i > 9 && i < 100){
	//		int zw1 = (int) floorf(1.0*i/10);
	//		zw2[i] = (int) floorf(10*(1.0*i/10-zw1));
	//		counter++;
	//		//fprintf(stdout, "%i ", zw1);
	//	}
	//}
	//fprintf(stdout, "\n");
	//if(counter > 0){
	//	for(i = 0; i < 10; ++i){
	//		fprintf(stdout, "  ");
	//	}
	//	for(i = 10; i < 10+counter; ++i){
	//		fprintf(stdout, "%i ", zw2[i]);
	//	}
	//	fprintf(stdout, "\n");
	//}
	//free(zw2);

	counter = 0;	
    //if(drawit == 1){
    //    for(i = height-1; i >= 0; --i){
    //        int j;
    //        for(j = 0; j < width; ++j){
    //            if(gpoints[i*width+j] == 0){
    //                fprintf(stdout, "  ");
    //            }else{
    //                fprintf(stdout, "+ ");
    //            }
    //        }
    //        fprintf(stdout, "|%i\n", i);
    //    }
    //}
	free(points);
}
