// Copyright 2014-2015, Jean Rene Dawin
//
// This Program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.

#include "escwyp_chain_gui_elm_extern.h"
#include "escwyp_sine_robin_gui_elm_extern.h"
#include "escwyp_sine_grass_gui_elm_extern.h"
#include "escwyp_sine_grass_params.h"
#include "escwyp_nadelper_gui_elm_extern.h"
#include "escwyp_oszillo_extern.h"
#include "escwyp_misch_gui_elm_extern.h"
#include "escwyp_samplecast_gui_elm_extern.h"
#include "escwyp_samplecast_extern.h"
#include "escwyp_spratz_gui_elm_extern.h"
#include "escwyp_spratz_extern.h"
#include "escwyp_patch_select_gui_elm_extern.h"
#include "escwyp_klavier_extern.h"
#include "escwyp_main_gui_elm.h"
#include "escwyp_rec_gui_elm_extern.h"
#include "escwyp_globals_extern.h"
#ifdef ESCWYP_OUT_IS_JACK
	#include "escwyp_out_jack_extern.h"
#endif
#include "escwyp_out_none_extern.h"
#include "escwyp_misch_extern.h"
#include "escwyp_main.h"
// esceyp
// Toujours plus aff\^ut\'e ?

void escwypMainGuiInit(){

   // WIN
   win = elm_win_add(NULL, "Maskotti", ELM_WIN_BASIC);
   //win = elm_win_util_standard_add("maskotti", "Maskotti");
   elm_win_title_set(win, "Escwyp");
   //elm_win_screen_constrain_set(win, EINA_TRUE);
   // when the user clicks "close" on a window there is a request to delete
   evas_object_smart_callback_add(win, "delete,request", on_done, NULL);


   // BACKGROUND
   bg = elm_bg_add(win);
   elm_bg_file_set(bg, "escsf1.png", NULL);
   elm_bg_option_set(bg, ELM_BG_OPTION_TILE);
   elm_win_resize_object_add(win, bg);
   evas_object_size_hint_weight_set(bg, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   evas_object_show(bg);

   // WINBOX
   winbox = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(winbox, EINA_FALSE);
   //evas_object_size_hint_weight_set(winbox, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(winbox, EVAS_HINT_FILL, EVAS_HINT_FILL);

   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   elm_win_resize_object_add(win, winbox);
   //evas_object_geometry_set(winbox, 0, 0, 310, 310);
   evas_object_show(winbox);

   // WINTAB 
   wintab = elm_table_add(win);
   evas_object_show(wintab);
   evas_object_size_hint_align_set(wintab, 0.5, 0.0);
   evas_object_size_hint_weight_set(wintab, 0.5, 0.0);
   elm_box_pack_end(winbox, wintab);
   //evas_object_geometry_set(wintab, 0, 0, 600, 300);
   elm_table_padding_set(wintab, 2, 2);


   // SIZE SLIDER
   slid_ha = elm_slider_add(win);
   elm_slider_span_size_set(slid_ha, 100);
   //evas_object_size_hint_align_set(slid_ha, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_ha, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_ha, EINA_TRUE);
   elm_table_pack(wintab, slid_ha , 0, 0, 1, 1);
   //evas_object_show(slid_ha);

   slid_va = elm_slider_add(win);
   elm_slider_span_size_set(slid_va, 100);
   //evas_object_size_hint_align_set(slid_va, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_va, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_va, EINA_FALSE);
   elm_table_pack(wintab, slid_va , 0, 0, 1, 1);
   //evas_object_show(slid_va);

   // -------------------

   slid_hc = elm_slider_add(win);
   elm_slider_span_size_set(slid_hc, 200);
   //evas_object_size_hint_align_set(slid_hc, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_hc, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_hc, EINA_TRUE);
   elm_table_pack(wintab, slid_hc , 1, 0, 1, 1);
   //evas_object_show(slid_hc);

   slid_vc = elm_slider_add(win);
   elm_slider_span_size_set(slid_vc, 350);
   //evas_object_size_hint_align_set(slid_vc, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_vc, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_vc, EINA_FALSE);
   elm_table_pack(wintab, slid_vc , 1, 0, 1, 1);
   //evas_object_show(slid_vc);

   // -------------------

   slid_hp = elm_slider_add(win);
   elm_slider_span_size_set(slid_hp, 100);
   //evas_object_size_hint_align_set(slid_hp, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_hp, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_hp, EINA_TRUE);
   elm_table_pack(wintab, slid_hp , 2, 0, 1, 1);
   //evas_object_show(slid_hp);

   slid_vp = elm_slider_add(win);
   elm_slider_span_size_set(slid_vp, 300);
   //evas_object_size_hint_align_set(slid_vp, EVAS_HINT_FILL, 0.5);
   //evas_object_size_hint_weight_set(slid_vp, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //elm_win_resize_object_add(win, box);
   elm_slider_horizontal_set(slid_vp, EINA_FALSE);
   elm_table_pack(wintab, slid_vp , 2, 0, 1, 1);
   //evas_object_show(slid_vp);


   // BOXES

   // BOX WITH ADMIN CONTROLS ------------- //

   box_a = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_a, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   //elm_box_pack_end(box, box_a);
   //evas_object_size_hint_align_set(box_a, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_size_hint_weight_set(box_a, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_geometry_set(box_a, 0, 0, 300, 300);
   evas_object_size_hint_align_set(box_a, 0.5, 0.0);
   evas_object_size_hint_weight_set(box_a, 0.5, 0.5);
   evas_object_show(box_a);

   // ADMINTAB 
   admintab = elm_table_add(win);
   evas_object_show(admintab);
   evas_object_size_hint_align_set(admintab, 0.5, 0.0);
   evas_object_size_hint_weight_set(admintab, 0.5, 0.5);
   elm_box_pack_end(box_a, admintab);
   //evas_object_geometry_set(admintab, 0, 0, 600, 300);
   elm_table_padding_set(admintab, 2, 2);
   // ------------------------------- //

   // BOX WITH SYNTH CONTROLS ------------- //
   box_c = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_c, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box_c, 0.5, 0.0);
   evas_object_size_hint_weight_set(box_c, 0.5, 0.5);
   //evas_object_geometry_set(box_c, 0, 0, 300, 300);
   evas_object_show(box_c);

   // UP BOX - SELECT THE SYNTH METHOD
   box_cu = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_cu, EINA_TRUE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box_cu, 0.5, 0.0);
   evas_object_size_hint_weight_set(box_cu, 0.5, 0.0);
   //evas_object_geometry_set(box_cu, 0, 0, 300, 300);
   elm_box_pack_end(box_c, box_cu);
   evas_object_show(box_cu);

    // AZZURRI
   lab_azz = elm_label_add(win);
   elm_object_text_set(lab_azz, "//////// Azzurri ///////");
   elm_box_pack_end(box_c, lab_azz);
   evas_object_show(lab_azz);
    //

   // DOWN BOX - THE SYNTH CONTROLS
   box_cd = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_cd, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box_cd, 0.5 , 0.5);
   evas_object_size_hint_weight_set(box_cd, 0.5, 0.5);
   //evas_object_geometry_set(box_cd, 0, 0, 300, 300);
   elm_box_pack_end(box_c, box_cd);
   evas_object_show(box_cd);

   // ------------------------------- //
   // REC BOX - MAIN BOX
   box_rec = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_rec, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   //evas_object_size_hint_align_set(box_rec, 0.5 , 0.5);
   //evas_object_size_hint_weight_set(box_rec, 0.5, 0.5);

    // KLEBT OBEN:
    //evas_object_size_hint_align_set(box_rec, 0.5, -0.5);
    // KLEBT ZIEMLICH OBEN:
    //evas_object_size_hint_align_set(box_rec, 0.5, 0.0);
    // KLEBT ZIEMLICH UNTEN:
    //evas_object_size_hint_align_set(box_rec, 0.5, 0.5);
    // KLEBT UNTEN:
    evas_object_size_hint_align_set(box_rec, 0.5, 1.0);
    evas_object_size_hint_weight_set(box_rec, 0.0, 0.0);
    // KLEBT OBEN und IST LINKS ABGESCHNITTEN:
    //evas_object_size_hint_align_set(box_rec, -0.5, -0.5);

   //evas_object_geometry_set(box_rec, 0, 0, 300, 300);
   elm_box_pack_end(box_c, box_rec);
   evas_object_show(box_rec);

   // FIRST REC BOX - TOP
   box1_rec = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box1_rec, EINA_TRUE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box1_rec, 0.5 , 0.5);
   evas_object_size_hint_weight_set(box1_rec, 0.5, 0.5);
   //evas_object_geometry_set(box1_rec, 0, 0, 300, 300);
   elm_box_pack_end(box_rec, box1_rec);
   evas_object_show(box1_rec);

   // SECOND REC BOX - BELOW THE FIRST ONE
   box2_rec = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box2_rec, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box2_rec, 0.5 , 0.5);
   evas_object_size_hint_weight_set(box2_rec, 0.5, 0.5);
   //evas_object_geometry_set(box2_rec, 0, 0, 300, 300);
   elm_box_pack_end(box_rec, box2_rec);
   evas_object_show(box2_rec);
   // ------------------------------- //
   // BOX WITH PATCHES ------------- //

   box_p = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_p, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   //elm_box_pack_end(box, box_p);
   evas_object_size_hint_align_set(box_p, 0.5, 0.0);
   evas_object_size_hint_weight_set(box_p, 0.5, 0.5);
   //evas_object_geometry_set(box_p, 0, 0, 300, 300);
   evas_object_show(box_p);

   // ------------------------------- //
   // BOX WITH KLAVIER ------------- //

   box_k = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_k, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   evas_object_size_hint_align_set(box_k, EVAS_HINT_FILL, EVAS_HINT_FILL);
   evas_object_size_hint_weight_set(box_k, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_geometry_set(box_k, 0, 0, 300, 300);
   elm_box_pack_end(winbox, box_k);
   //elm_table_pack(wintab, box_k , 0, 1, 3, 1);
   evas_object_show(box_k);

   // ------------------------------- //
   // BOX WITH OSZILLO ------------- //

   box_o = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_o, EINA_FALSE);
   // add object as a resize object for the window (controls window minimum
   // size as well as gets resized if window is resized)
   //elm_win_resize_object_add(win, base_box);
   //elm_box_pack_end(box, box_o);
   //evas_object_size_hint_align_set(box_o, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_size_hint_weight_set(box_o, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_geometry_set(box_o, 0, 0, 300, 300);
   elm_box_pack_end(winbox, box_o);
   //elm_table_pack(wintab, box_o , 0, 2, 3, 1);
   evas_object_show(box_o);

   // ------------------------------- //


     //// FRAMES

   frame_a = elm_frame_add(win);
   elm_object_part_text_set(frame_a, NULL, "Admin");
   elm_object_part_content_set(frame_a, NULL, box_a);
   //elm_object_part_content_set(frame_a, NULL, box_p);
    //evas_object_size_hint_min_set(frame_a, 300, 300);
   evas_object_size_hint_align_set(frame_a, 0, EVAS_HINT_FILL);
   evas_object_size_hint_weight_set(frame_a, 0, EVAS_HINT_EXPAND);
    //evas_object_event_callback_add(frame_a, EVAS_CALLBACK_RESIZE, _on_resize_of_frame_b, NULL);
   //evas_object_geometry_set(frame_a, 0, 0, 300, 300);
   //elm_box_pack_end(base_box, frame_a);
    //evas_object_size_hint_min_set(frame_a, 300, 300);
    //evas_object_size_hint_max_set(frame_a, 300, 300);
   //elm_table_pack(wintab, frame_a , 1, 0, 1, 1);
   //elm_win_resize_object_add(win, frame_a);
   elm_table_pack(wintab, frame_a , 0, 0, 1, 1);
   evas_object_show(frame_a);

   frame_c = elm_frame_add(win);
   elm_object_part_text_set(frame_c, NULL, "Schieber und Knöpfe");
   elm_object_part_content_set(frame_c, NULL, box_c);
    //evas_object_size_hint_min_set(frame_c, 100, 100);
   evas_object_size_hint_align_set(frame_c, 0, EVAS_HINT_FILL);
   evas_object_size_hint_weight_set(frame_c, 0, EVAS_HINT_EXPAND);
    //evas_object_event_callback_add(frame_c, EVAS_CALLBACK_RESIZE, _on_resize_of_frame_a, NULL);
   //evas_object_geometry_set(frame_c, 0, 0, 100, 100);
   //elm_box_pack_end(base_box, frame_c);
    //evas_object_size_hint_min_set(frame_c, 300, 300);
    //evas_object_size_hint_max_set(frame_c, 300, 300);
   elm_table_pack(wintab, frame_c, 1, 0, 1, 1);
   evas_object_show(frame_c);


    frame_p = elm_frame_add(win);
    elm_object_part_text_set(frame_p, NULL, "Patches");
    elm_object_part_content_set(frame_p, NULL, box_p);
   evas_object_size_hint_align_set(frame_p, 0, EVAS_HINT_FILL);
   evas_object_size_hint_weight_set(frame_p, 0, EVAS_HINT_EXPAND);
   elm_table_pack(wintab, frame_p , 2, 0, 1, 1);
    evas_object_show(frame_p);
    

   // RADIO
   // the radio buttons hiding the sine_grass gui/nadelper/samplecast stuff if checked and showing it

   gui_change_radio_0 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_0, 0);
   elm_object_part_text_set(gui_change_radio_0, NULL, "Chain");
   evas_object_smart_callback_add(gui_change_radio_0, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_0);
   evas_object_show(gui_change_radio_0);

   gui_change_radio_1 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_1, 1);
   elm_radio_group_add(gui_change_radio_1, gui_change_radio_0);
   elm_object_part_text_set(gui_change_radio_1, NULL, "SineRobin");
   evas_object_smart_callback_add(gui_change_radio_1, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_1);
   evas_object_show(gui_change_radio_1);

   gui_change_radio_2 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_2, 2);
   elm_radio_group_add(gui_change_radio_2, gui_change_radio_0);
   elm_object_part_text_set(gui_change_radio_2, NULL, "SineGrass");
   evas_object_smart_callback_add(gui_change_radio_2, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_2);
   evas_object_show(gui_change_radio_2);

   gui_change_radio_3 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_3, 3);
   elm_radio_group_add(gui_change_radio_3, gui_change_radio_0);
   elm_object_part_text_set(gui_change_radio_3, NULL, "Nadelper");
   evas_object_smart_callback_add(gui_change_radio_3, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_3);
   evas_object_show(gui_change_radio_3);

   gui_change_radio_4 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_4, 4);
   elm_radio_group_add(gui_change_radio_4, gui_change_radio_0);
   elm_object_part_text_set(gui_change_radio_4, NULL, "Samplecast");
   evas_object_smart_callback_add(gui_change_radio_4, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_4);
   evas_object_show(gui_change_radio_4);

   gui_change_radio_5 = elm_radio_add(win);
   elm_radio_state_value_set(gui_change_radio_5, 5);
   elm_radio_group_add(gui_change_radio_5, gui_change_radio_0);
   elm_object_part_text_set(gui_change_radio_5, NULL, "Spratz");
   evas_object_smart_callback_add(gui_change_radio_5, "changed", gui_change_radio_fun, NULL);
   elm_box_pack_end(box_cu, gui_change_radio_5);
   evas_object_show(gui_change_radio_5);

   //evas_object_show(gui_change_radio_0);
   //evas_object_show(gui_change_radio_1);
   //evas_object_show(gui_change_radio_2);
   //evas_object_show(gui_change_radio_3);
   //evas_object_show(gui_change_radio_4);
   //evas_object_show(gui_change_radio_5);

    // SCROLLER -OSZILLOSKOP

   scr_oszillo = elm_scroller_add(win);
   //elm_win_resize_object_add(win, scr_oszillo);
   evas_object_size_hint_weight_set(scr_oszillo, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   evas_object_size_hint_align_set(scr_oszillo, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_size_hint_min_set(scr_oszillo, 1000, 1000);
   evas_object_size_hint_max_set(scr_oszillo, 800, 200);
   elm_scroller_content_min_limit(scr_oszillo, EINA_TRUE, EINA_TRUE);
   //evas_object_smart_callback_add(scr_oszillo, "scroll,up", scr_scroll_fun, NULL);
   //elm_scroller_page_size_set(scr_oszillo, 1000, 1000);
   //elm_table_pack(wintab, scr_oszillo , 0, 2, 3, 1);
   evas_object_show(scr_oszillo);
   elm_box_pack_end(box_o, scr_oszillo);


   //----INIT-----------------
   packGuiFuns[0] = chainPackGui;
   packGuiFuns[1] = sineRobinPackGui;
   packGuiFuns[2] = sineGrassPackGui;
   packGuiFuns[3] = nadelperPackGui;
   packGuiFuns[4] = samplecastPackGui;
   packGuiFuns[5] = spratzPackGui;
   unpackGuiFuns[0] = chainUnpackGui;
   unpackGuiFuns[1] = sineRobinUnpackGui;
   unpackGuiFuns[2] = sineGrassUnpackGui;
   unpackGuiFuns[3] = nadelperUnpackGui;
   unpackGuiFuns[4] = samplecastUnpackGui;
   unpackGuiFuns[5] = spratzUnpackGui;


   int wintab_count = 0;

//lab_ok, lab_vol, lab_keybd, lab_osc_res, lab_about;
   // Label for OK
   lab_ok = elm_label_add(win);
   elm_object_text_set(lab_ok, "Exit escwyp");
   elm_table_pack(admintab, lab_ok, 0, wintab_count++, 1, 1);
   evas_object_show(lab_ok);

   // OK / EXIT
   btn_exit = elm_button_add(win);
   elm_object_text_set(btn_exit, "OK");
   elm_table_pack(admintab, btn_exit, 0, wintab_count++, 1, 1);
   evas_object_show(btn_exit);
   evas_object_smart_callback_add(btn_exit, "clicked", on_done, NULL);

   // Label for separation
   //lab_trenn = elm_label_add(win);
   //elm_object_text_set(lab_trenn, " ");
   //elm_table_pack(admintab, lab_trenn, 0, wintab_count++, 1, 1);
   //evas_object_show(lab_trenn);

   Evas_Object *sepa = elm_separator_add(win);
   elm_separator_horizontal_set(sepa, EINA_TRUE);
   elm_table_pack(admintab, sepa, 0, wintab_count++, 1, 1);
   evas_object_show(sepa);

   Evas_Object **fetch_arr = malloc(10 * sizeof(Evas_Object *));

   // Label for volume
   lab_vol = elm_label_add(win);
   elm_object_text_set(lab_vol, "Audio volume");
   elm_table_pack(admintab, lab_vol, 0, wintab_count++, 1, 1);
   evas_object_show(lab_vol);

   int miret = mischInitGuiElm();
   if(miret <= 10){
      mischGuiElmPostbox(fetch_arr);
      int i;
      for(i = 0; i < miret; ++i){
	 elm_table_pack(admintab, fetch_arr[i], 0, wintab_count++, 1, 1);
      }
   }else{
     fprintf(stdout, "Too many GUI-Elements misch.\n");
   }
   // Label for separation
   //lab_trenn = elm_label_add(win);
   //elm_object_text_set(lab_trenn, " ");
   //elm_table_pack(admintab, lab_trenn, 0, wintab_count++, 1, 1);
   //evas_object_show(lab_trenn);
   sepa = elm_separator_add(win);
   elm_separator_horizontal_set(sepa, EINA_TRUE);
   elm_table_pack(admintab, sepa, 0, wintab_count++, 1, 1);
   evas_object_show(sepa);


   chainInitGuiElm(0);
   sineRobinInitGui();
   //struct sine_grass_params tmp_params;
   //sine_grass_set_params(&tmp_params);
   //sine_grass_init_values(0.0);
   //initSineRobinGui();
   sineGrassInitGui(0);
   //sineGrassPackGui(box_cd); 
   nadelperInitGui(1);
   samplecastInitGuiElm(0);
   spratzInitGuiElm(0);
   recInitGuiElm();
   recPackGui(box1_rec, box2_rec);
   fprintf(stdout, "c b b b\n");



   miret = klavierInitGui();
   if(miret <= 10){
      klavierGuiPostbox(fetch_arr);
      elm_box_pack_end(box_k, fetch_arr[0]);
//      // Label for piano controls
//      lab_keybd_poly = elm_label_add(win);
//      elm_object_text_set(lab_keybd_poly, "Keyboard polyphony");
//      elm_table_pack(admintab, lab_keybd_poly, 0, wintab_count++, 1, 1);
//      evas_object_show(lab_keybd_poly);
//
//      elm_table_pack(admintab, fetch_arr[1], 0, wintab_count++, 1, 1);
//      // Label for separation
//      lab_trenn = elm_label_add(win);
//      elm_object_text_set(lab_trenn, " ");
//      elm_table_pack(admintab, lab_trenn, 0, wintab_count++, 1, 1);
//      evas_object_show(lab_trenn);
//
//      // Label for piano controls 2
//      lab_keybd_ignore = elm_label_add(win);
//      elm_object_text_set(lab_keybd_ignore, "Decouple keyboard");
//      elm_table_pack(admintab, lab_keybd_ignore, 0, wintab_count++, 1, 1);
//      evas_object_show(lab_keybd_ignore);
//
//      elm_table_pack(admintab, fetch_arr[2], 0, wintab_count++, 1, 1);
//      // Label for separation
//      //lab_trenn = elm_label_add(win);
//      //elm_object_text_set(lab_trenn, " ");
//      //elm_table_pack(admintab, lab_trenn, 0, wintab_count++, 1, 1);
//      //evas_object_show(lab_trenn);
//      sepa = elm_separator_add(win);
//      elm_separator_horizontal_set(sepa, EINA_TRUE);
//      elm_table_pack(admintab, sepa, 0, wintab_count++, 1, 1);
//      evas_object_show(sepa);


   }else{
     fprintf(stdout, "Too many GUI-Elements klavier.\n");
   }

   klavier_init_keygrabs();
   //oszilloInitGui(scr_oszillo, box_a);
   miret = oszilloInitGui();
   if(miret <= 10){
      oszilloGuiPostbox(fetch_arr);
      elm_object_content_set(scr_oszillo, fetch_arr[0]);

      // Label for oszillo control
      lab_osc_res = elm_label_add(win);
      elm_object_text_set(lab_osc_res, "Oszillo zoom");
      elm_table_pack(admintab, lab_osc_res, 0, wintab_count++, 1, 1);
      evas_object_show(lab_osc_res);

      elm_table_pack(admintab, fetch_arr[1], 0, wintab_count++, 1, 1);

      sepa = elm_separator_add(win);
      elm_separator_horizontal_set(sepa, EINA_TRUE);
      elm_table_pack(admintab, sepa, 0, wintab_count++, 1, 1);
      evas_object_show(sepa);


   }else{
     fprintf(stdout, "Too many GUI-Elements oszillo.\n");
   }

   // ABOUT 
   btn_about = elm_button_add(win);
   elm_object_text_set(btn_about, "About");
   evas_object_show(btn_about);
   evas_object_smart_callback_add(btn_about, "clicked", btn_about_fun, NULL);
   elm_table_pack(admintab, btn_about, 0, wintab_count++, 1, 1);

   // BOX FOR SWITCHING BACKEND 
   box_be = elm_box_add(win);
   // make the box horizontal
   elm_box_horizontal_set(box_be, EINA_TRUE);
   evas_object_size_hint_align_set(box_be, 0.5, 0.0);
   evas_object_size_hint_weight_set(box_be, 0.5, 0.0);
   elm_table_pack(admintab, box_be, 0, wintab_count++, 1, 1);
   evas_object_show(box_be);

   //bakcend
   backend_switch_jack_radio = elm_radio_add(win);
   elm_radio_state_value_set(backend_switch_jack_radio, 0);
   elm_object_part_text_set(backend_switch_jack_radio, NULL, "Jack");
   evas_object_smart_callback_add(backend_switch_jack_radio, "changed", backend_switch_radio_fun, NULL);
   elm_box_pack_end(box_be, backend_switch_jack_radio);
   evas_object_show(backend_switch_jack_radio);

   backend_switch_alsa_radio = elm_radio_add(win);
   elm_radio_state_value_set(backend_switch_alsa_radio, 1);
   elm_radio_group_add(backend_switch_alsa_radio, backend_switch_jack_radio);
   elm_object_part_text_set(backend_switch_alsa_radio, NULL, "Alsa");
   evas_object_smart_callback_add(backend_switch_alsa_radio, "changed", backend_switch_radio_fun, NULL);
   elm_box_pack_end(box_be, backend_switch_alsa_radio);
   evas_object_show(backend_switch_alsa_radio);

   backend_switch_none_radio = elm_radio_add(win);
   elm_radio_state_value_set(backend_switch_none_radio, 2);
   elm_radio_group_add(backend_switch_none_radio, backend_switch_jack_radio);
   elm_object_part_text_set(backend_switch_none_radio, NULL, "None");
   evas_object_smart_callback_add(backend_switch_none_radio, "changed", backend_switch_radio_fun, NULL);
   elm_box_pack_end(box_be, backend_switch_none_radio);
   evas_object_show(backend_switch_none_radio);

   fprintf(stdout, " OUTM = %i ++++++\n", out_m);
   if(out_m == jack){
      elm_radio_value_set(backend_switch_jack_radio , 0);
   }
   if(out_m == alsa){
      elm_radio_value_set(backend_switch_jack_radio , 1);
   }
   if(out_m == none){
      elm_radio_value_set(backend_switch_jack_radio , 2);
   }
  
#ifndef ESCWYP_OUT_IS_JACK
   elm_object_disabled_set(backend_switch_jack_radio, EINA_TRUE);
#endif
#ifndef ESCWYP_OUT_IS_ALSA
   elm_object_disabled_set(backend_switch_alsa_radio, EINA_TRUE);
#endif

   escwypPatchSelectInitGuiElm(box_p);
   //escwyp_refresh_patch_selector();

   if(fetch_arr){
      free(fetch_arr);
   }
   fprintf(stdout, "FETCH_ARR FREED\n");
   //------------------


    // THE PANEL

   //panbox = elm_box_add(win);
   //// make the box horizontal
   //elm_box_horizontal_set(panbox, EINA_FALSE);
   //// add object as a resize object for the window (controls window minimum
   //// size as well as gets resized if window is resized)
   ////elm_win_resize_object_add(win, panbox);
   //elm_box_pack_end(winbox, panbox);
   ////evas_object_geometry_set(winbox, 0, 0, 310, 310);
   //evas_object_show(panbox);

   //panel_a = elm_panel_add(win);
   //elm_panel_orient_set(panel_a, ELM_PANEL_ORIENT_RIGHT);
   //elm_panel_hidden_set(panel_a, EINA_TRUE);
   //elm_panel_toggle(panel_a);
   //evas_object_size_hint_weight_set(panel_a, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(panel_a, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_show(panel_a);
   //elm_box_pack_end(panbox, panel_a);

   //panel_b = elm_panel_add(win);
   //elm_panel_orient_set(panel_b, ELM_PANEL_ORIENT_BOTTOM);
   //elm_panel_hidden_set(panel_b, EINA_TRUE);
   //elm_panel_toggle(panel_b);
   //evas_object_size_hint_weight_set(panel_b, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(panel_b, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //evas_object_show(panel_b);
   //elm_box_pack_end(panbox, panel_b);

   // // THE PANEL BUTTOUNS
   //but_pa = elm_button_add(win);
   //// set default text of button to "OK"
   //elm_object_text_set(but_pa, "PAPAPAPAPA PAPAPAPA");
   //// pack the button at the end of the box
   //evas_object_geometry_set(but_pa, 0, 0, 90, 90);
   //elm_object_content_set(panel_a, but_pa);
   //evas_object_show(but_pa);

   //but_pb = elm_button_add(win);
   //// set default text of button to "OK"
   //elm_object_text_set(but_pb, "PBPBPBPBP PBPB");
   //// pack the button at the end of the box
   //evas_object_geometry_set(but_pb, 0, 0, 90, 90);
   //elm_object_content_set(panel_b, but_pb);
   //evas_object_show(but_pb);

   // has to be down here, so that the win knows its size well
   evas_object_show(win);
   elm_radio_value_set(gui_change_radio_0, 1);
   elm_radio_value_set(gui_change_radio_0, 0);
   gui_change_radio_fun(NULL, gui_change_radio_0, NULL);

   //packGuiFuns[0](box_cd);
   fprintf(stdout, "b b b b\n");
}

static void btn_about_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis btn_about_fun\n");
   fprintf(stdout, "playsth=%i, current_sound_function=%i, \n", playsth, current_sound_function);
   oszillo_set_schweif(0);

}
static void backend_switch_radio_fun(void *data, Evas_Object *obj, void *event_info)
{
   backend_switch_radio_val = elm_radio_value_get(obj);
   fprintf(stdout, "Yis backend_switch_radio_fun %i\n", backend_switch_radio_val);
   escwyp_switch_backend(backend_switch_radio_val);
   elm_radio_value_set(backend_switch_jack_radio , out_m);
   backend_switch_radio_val = out_m;
}

static void on_done(void *data, Evas_Object *obj, void *event_info)
{
   fprintf(stdout, "Yis OK\n");
   shutdown_stuff();
   // quit the mainloop (elm_run function will return)
   elm_exit();
}

static void gui_change_radio_fun(void *data, Evas_Object *obj, void *event_info)
{

   fprintf(stdout, "Yis show_change_stuff_fun\n");
   gui_change_radio_val = elm_radio_value_get(obj);

   unpackGuiFuns[gui_change_radio_val_prev](box_cd);
   packGuiFuns[gui_change_radio_val](box_cd);

   escwyp_switch_method(gui_change_radio_val);

   escwyp_refresh_patch_selector();
      
   fprintf(stdout, "gui_change_radio_val_prev = %i, gui_change_radio_val = %i \n", gui_change_radio_val_prev, gui_change_radio_val);
   gui_change_radio_val_prev = gui_change_radio_val;
   //int x, y, w, h;
   //evas_object_geometry_get(win, &x, &y, &w, &h);
   //fprintf(stdout, "jjjjj WIN SIZE DAVOR  x: %i, y: %i, w: %i, h: %i\n", x, y, w, h);
   //evas_object_geometry_set(win, x, y, w, h);
   //fprintf(stdout, "jjjjj WIN SIZE DANACH x: %i, y: %i, w: %i, h: %i\n", x, y, w, h);
    
}

//TODO: deprecated
void escwyp_main_gui_backend_switch_jack_radio_set(const int val)
{

   elm_radio_value_set(backend_switch_jack_radio, val);

}
