// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.

#ifndef ESCWYP_MISCH_H
#define ESCWYP_MISCH_H
#include "escwyp_globals_extern_basic.h"
#include "escwyp_global_defines.h"
//#include "escwyp_sound_params.h"
#include "escwyp_chain_extern.h"
#include "escwyp_sine_robin_extern.h"
#include "escwyp_sine_grass_extern.h"
#include "escwyp_nadelper_extern.h"
#include "escwyp_samplecast_extern.h"
#include "escwyp_spratz_extern.h"
#include "escwyp_klavier_extern.h"
#include "escwyp_out_txt_extern.h"

static struct chain_params the_ch_params[MAX_NUM_NOTES];
static struct sine_robin_params the_sr_params[MAX_NUM_NOTES];
static struct sine_grass_params the_sg_params[MAX_NUM_NOTES];
static struct nadelper_params the_np_params[MAX_NUM_NOTES];
static struct samplecast_params the_sc_params[MAX_NUM_NOTES];
static struct spratz_params the_sp_params[MAX_NUM_NOTES];

float *mix_buff = NULL;
static float mix_volume = 0.4;

static int ixs[klavier_max_freq_array_size];
static int nts[MAX_NUM_NOTES];
static int hls[MAX_NUM_NOTES];
static int num_nts = 0;
static int num_nts_saved = 0;
static int num_hls = 0;

// note_index_first == [10, 20, 30, ..., 40, 50]
//                      ^^  
// note_index_after_first == [10, 20, 30, ..., 40, 50]
//                                ^^
// note_index_at_last == [10, 20, 30, ..., 40, 50]
//                                             ^^  
// note_index_after_last == [10, 20, 30, ..., 40, 50]
//                                                   ^^  
//static int note_index_first = 0; 
//static int note_index_after_first = 0;
//static int note_index_at_last = 0;
//static int note_index_after_last = 0;

void misch_init();
void misch_init_buffer(const int length);
void misch(int length);
void insert_hole(const int place);
int note_on(const int id);
int note_off(const int id);
void escwyp_migrate_notes();
void clear_notes();
int get_current_sound_func();
void print_nts();
void print_ixs();
void print_note_params();

void call_sound_func(int id, int length);
void set_params(int id, int stimme);
void refresh_params(int id);
void initialise_params(const int sound_method, const int note_id);
void set_mix_volume(const float a_volume); 
float get_mix_volume(); 
int get_playing_status();
void misch_save_num_nts();
void misch_restore_num_nts();
int note_is_set(const int id);
#endif
