// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include "escwyp_nadelper_patch_eet.h"
#include "escwyp_nadelper_extern.h"
#include "escwyp_nadelper_gui_elm_extern.h"
#include "escwyp_patch_select_extern.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void nadelper_load_patch(const char *patch_name){

	fprintf(stdout, "III nadelper_load_patch\n");

	void *param_p = NULL;
	void *param_pp = NULL;
	char the_base_key[255];
	char the_key[255];
	the_base_key[0] = 47;
	the_base_key[1] = 0;
	strcat(the_base_key, "nadelper/"); 
	strcat(the_base_key, patch_name);

        // NADEL SIZE----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_nadel_size");

        if(param_pp){
	   param_pp = escwyp_patch_load_param(param_p, the_key);
	   float *nadelper_nadel_size = (float *) param_pp;
	   nadelper_set_nadel_size(*nadelper_nadel_size);
	   nadelper_nadel_size_slider_set(*nadelper_nadel_size);

	   fprintf(stdout, "%s %f\n", the_key, *nadelper_nadel_size);
	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

        // NUM FREQS----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_num_freqs");
	param_pp = escwyp_patch_load_param(param_p, the_key);

        if(param_pp){
	   int *nadelper_num_freqs = (int *) param_pp;
	   nadelper_set_num_freqs(*nadelper_num_freqs);
	   nadelper_num_freqs_slider_set(*nadelper_num_freqs);

	   fprintf(stdout, "%s %i\n", the_key, *nadelper_num_freqs);
	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

        // LOWEST FREQ----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_lowest_freq");
	param_pp = escwyp_patch_load_param(param_p, the_key);
        if(param_pp){
	   int *nadelper_lowest_freq = (int *) param_pp;
           nadelper_params_lowest_freq_set(*nadelper_lowest_freq);
	   nadelper_lowest_freq_slider_set(*nadelper_lowest_freq);

	   fprintf(stdout, "%s %i\n", the_key, *nadelper_lowest_freq);
	   free(param_pp);
        }else{
	   fprintf(stdout, "%s not there. Ohh.\n", the_key);
	}
        //--------------------------------

        // HIGHEST FREQ----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_highest_freq");
	param_pp = escwyp_patch_load_param(param_p, the_key);

        if(param_pp){
	   int *nadelper_highest_freq = (int *) param_pp;
	   nadelper_set_highest_freq(*nadelper_highest_freq);
	   nadelper_highest_freq_slider_set(*nadelper_highest_freq);

	   fprintf(stdout, "%s %i\n", the_key, *nadelper_highest_freq);
	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

        // FREQ STEP SIZE----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_freq_step_size");
	param_pp = escwyp_patch_load_param(param_p, the_key);

        if(param_pp){
	   int *nadelper_freq_step_size = (int *) param_pp;
	   nadelper_set_freq_step_size(*nadelper_freq_step_size);
	   nadelper_freq_step_size_slider_set(*nadelper_freq_step_size);

	   fprintf(stdout, "%s %i\n", the_key, *nadelper_freq_step_size);
	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

        // RANDOM STEP SIZE ACTIVE----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_random_step_size_active");
	param_pp = escwyp_patch_load_param(param_p, the_key);

        if(param_pp){
	   int *nadelper_random_step_size_active = (int *) param_pp;
	   nadelper_set_random_step_size_active(*nadelper_random_step_size_active);
	   nadelper_random_step_size_active_check_set(*nadelper_random_step_size_active);

	   fprintf(stdout, "%s %i\n", the_key, *nadelper_random_step_size_active);
	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

        // STEP SIZE RANDOM RANGE----------------------
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_step_size_random_range");
	param_pp = escwyp_patch_load_param(param_p, the_key);

        if(param_pp){
   	   int *nadelper_step_size_random_range = (int *) param_pp;
   	   nadelper_set_step_size_random_range(*nadelper_step_size_random_range);
   	   nadelper_step_size_random_range_slider_set(*nadelper_step_size_random_range);
   
   	   fprintf(stdout, "%s %i\n", the_key, *nadelper_step_size_random_range);
   	   free(param_pp);
        }else{
           fprintf(stdout, "%s not there. Ohh.\n", the_key);
        }
        //--------------------------------

}

void nadelper_save_patch(const char *patch_name){

	fprintf(stdout, "nadelper_save_patch\n");
	float nadelper_nadel_size = 0.0;
	int nadelper_num_freqs = 0;
	int nadelper_lowest_freq = 0;
	int nadelper_highest_freq = 0;
	int nadelper_freq_step_size = 0;
	int nadelper_random_step_size_active = 0;
	int nadelper_step_size_random_range = 0;

	char id_string[255];
	strcpy(id_string, "/PATCH_NAME/nadelper/");
	strcat(id_string, patch_name);
	escwyp_patch_save_param(patch_name, (1+strlen(patch_name))*sizeof(char), id_string);
	fprintf(stdout, "%s = %s\n", id_string, patch_name);

	char the_base_key[255];
	char the_key[255];
	the_base_key[0] = 47;
	the_base_key[1] = 0;
	strcat(the_base_key, "nadelper/"); 
	strcat(the_base_key, patch_name);


	nadelper_nadel_size = nadelper_get_nadel_size();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_nadel_size");
	escwyp_patch_save_param(&nadelper_nadel_size, sizeof(float), the_key);
	fprintf(stdout, "%s %f\n", the_key, nadelper_nadel_size);

	nadelper_num_freqs = nadelper_get_num_freqs();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_num_freqs");
	escwyp_patch_save_param(&nadelper_num_freqs, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_num_freqs);

	nadelper_lowest_freq = nadelper_params_lowest_freq_get();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_lowest_freq");
	escwyp_patch_save_param(&nadelper_lowest_freq, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_lowest_freq);

	nadelper_highest_freq = nadelper_get_highest_freq();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_highest_freq");
	escwyp_patch_save_param(&nadelper_highest_freq, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_highest_freq);

	nadelper_freq_step_size = nadelper_get_freq_step_size();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_freq_step_size");
	escwyp_patch_save_param(&nadelper_freq_step_size, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_freq_step_size);

	nadelper_random_step_size_active = nadelper_get_random_step_size_active();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_random_step_size_active");
	escwyp_patch_save_param(&nadelper_random_step_size_active, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_random_step_size_active);

	nadelper_step_size_random_range = nadelper_get_step_size_random_range();
	strcpy(the_key, the_base_key);
	strcat(the_key, "/nadelper_step_size_random_range");
	escwyp_patch_save_param(&nadelper_step_size_random_range, sizeof(int), the_key);
	fprintf(stdout, "%s %i\n", the_key, nadelper_step_size_random_range);

}

