// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.

#ifndef ESCWYP_OSZILLO_H
#define ESCWYP_OSZILLO_H
#include <Evas.h>
#include "escwyp_globals_extern.h"
#include <semaphore.h>

static Evas_Object *im;
static Evas_Object *oszillo_resolution_slider;
//Evas_Object *oszillo_base_box;
static Evas *canv;
static Ecore_Timer *oszillo_timer;
static int im_width = 1000;
static int im_height = 200;
static unsigned int *pixels;
static unsigned int *pixels_base;
static unsigned short *pixels_dirty;
static int pixels_group_size = 1;
static int num_pixels_drawn = 0;
static int pict_count = 0;
static int font_size[3] = {100,50,10};
static int zurueck = 0;
static int schweif = 0;
static int over = 0;

// buffer for oszillo data
static float *osz_b = NULL;
// buffer position
static int bp = 0;
// buffer size
static int bs = 0;
// if semaphore copy_sem is 0, samples can be copied into the osz_b buffer. 
// If it is 1 the oszilloskop will be drawn.
static sem_t copy_sem;
// copy mischbuff to osz_b
void oszilloCopyBuffer(const int mbs, const float *mb);


int oszilloInitGui();
void oszilloInitSem();
void oszilloInitBuffer(const int size);
void oszilloGuiPostbox(Evas_Object **obj_arr);
void oszillo_set_schweif(const int value);
static Eina_Bool oszillo_func(void *data);
static void makeOszilloskop();
static void makeOszilloskopScaled();
static int theMaxAbsVal(const int start, const int size, const float *data);
static void oszillo_resolution_slider_fun(void *data, Evas_Object *obj, void *event_info);
int get_pixels_group_size();
void set_pixels_group_size(const int a_size);
static void draw_escwyp(const int *points, const int width, const int height, const int xoff, const int yoff);
static void gen_escwyp(const int w, const int h, const int xoff, const int yoff);

#endif
