// Copyright 2015, Jean Rene Dawin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version. See License-GPL-2.txt.

#include <Elementary.h>
#include "escwyp_sine_grass_gui_elm.h"
#include "escwyp_sine_grass_extern.h"

void sineGrassPackGui(Evas_Object *box){

    elm_box_pack_end(box, sine_grass_freq_slider);
    evas_object_show(sine_grass_freq_slider);
    if(sine_grass_get_self_control()){
       elm_object_disabled_set(sine_grass_freq_slider, EINA_FALSE);
    }else{
       elm_object_disabled_set(sine_grass_freq_slider, EINA_TRUE);
    }

    elm_box_pack_end(box, grass_mowed_check);
    evas_object_show(grass_mowed_check);

    elm_box_pack_end(box, grass_hill_fraction_slider);
    evas_object_show(grass_hill_fraction_slider);

    elm_box_pack_end(box, box_check);
    evas_object_show(box_check);

    elm_box_pack_end(box_check, sg_check_0);
    evas_object_show(sg_check_0);

    elm_box_pack_end(box_check, sg_check_1);
    evas_object_show(sg_check_1);

    elm_box_pack_end(box_check, sg_check_2);
    evas_object_show(sg_check_2);

    elm_box_pack_end(box_check, sg_check_3);
    evas_object_show(sg_check_3);

    elm_box_pack_end(box_check, sg_check_4);
    evas_object_show(sg_check_4);

    elm_box_pack_end(box_check, sg_check_5);
    evas_object_show(sg_check_5);

    elm_box_pack_end(box_check, sg_check_6);
    evas_object_show(sg_check_6);

    elm_box_pack_end(box_check, sg_check_7);
    evas_object_show(sg_check_7);

    elm_box_pack_end(box, box_radio);
    evas_object_show(box_radio);

    elm_box_pack_end(box_radio, sg_radio_0);
    evas_object_show(sg_radio_0);

    elm_box_pack_end(box_radio, sg_radio_1);
    evas_object_show(sg_radio_1);

    elm_box_pack_end(box_radio, sg_radio_2);
    evas_object_show(sg_radio_2);

    elm_box_pack_end(box_radio, sg_radio_3);
    evas_object_show(sg_radio_3);

    elm_box_pack_end(box, lawn_length_variation_frac_slider);
    evas_object_show(lawn_length_variation_frac_slider);

}

void sineGrassUnpackGui(Evas_Object *box){

    elm_box_unpack(box, sine_grass_freq_slider);
    evas_object_hide(sine_grass_freq_slider);

    elm_box_unpack(box, grass_mowed_check);
    evas_object_hide(grass_mowed_check);

    elm_box_unpack(box, grass_hill_fraction_slider);
    evas_object_hide(grass_hill_fraction_slider);

    elm_box_unpack(box, box_check);
    evas_object_hide(box_check);

    elm_box_unpack(box_check, sg_check_0);
    evas_object_hide(sg_check_0);

    elm_box_unpack(box_check, sg_check_1);
    evas_object_hide(sg_check_1);

    elm_box_unpack(box_check, sg_check_2);
    evas_object_hide(sg_check_2);

    elm_box_unpack(box_check, sg_check_3);
    evas_object_hide(sg_check_3);

    elm_box_unpack(box_check, sg_check_4);
    evas_object_hide(sg_check_4);

    elm_box_unpack(box_check, sg_check_5);
    evas_object_hide(sg_check_5);

    elm_box_unpack(box_check, sg_check_6);
    evas_object_hide(sg_check_6);

    elm_box_unpack(box_check, sg_check_7);
    evas_object_hide(sg_check_7);

    elm_box_unpack(box, box_radio);
    evas_object_hide(box_radio);

    elm_box_unpack(box_radio, sg_radio_0);
    evas_object_hide(sg_radio_0);

    elm_box_unpack(box_radio, sg_radio_1);
    evas_object_hide(sg_radio_1);

    elm_box_unpack(box_radio, sg_radio_2);
    evas_object_hide(sg_radio_2);

    elm_box_unpack(box_radio, sg_radio_3);
    evas_object_hide(sg_radio_3);

    elm_box_unpack(box, lawn_length_variation_frac_slider);
    evas_object_hide(lawn_length_variation_frac_slider);
}

void sineGrassInitGui(const int hidden){

   // the box containing all of the following
   //sine_grass_base_box = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   //elm_box_horizontal_set(distrib_base_box, EINA_TRUE);
   if(hidden == 0){
       //elm_box_pack_end(change_box, sine_grass_base_box);
       //evas_object_hide(sine_grass_base_box);
   }

   // the slider associated with the sine_grass_freq parameter in function makeSineGrass called by button "Key4"
   sine_grass_freq_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(sine_grass_freq_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(sine_grass_freq_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(sine_grass_freq_slider, "%1.2f SG_FREQ");
   elm_slider_indicator_show_set(sine_grass_freq_slider, EINA_FALSE);
   elm_slider_min_max_set(sine_grass_freq_slider, 20.0, 10000.0);
   elm_slider_value_set(sine_grass_freq_slider, sine_grass_params_sine_grass_freq_get());
   elm_slider_span_size_set(sine_grass_freq_slider, 200);
   evas_object_smart_callback_add(sine_grass_freq_slider, "delay,changed", sine_grass_freq_slider_fun, NULL);    

   // the ckeck-box setting grass_mowed to 0 or 1 in makeSineGrass
   grass_mowed_check =  elm_check_add(win);
   elm_check_state_set(grass_mowed_check, EINA_FALSE);
   elm_object_part_text_set(grass_mowed_check, NULL, "Mowe the grass!");
   evas_object_smart_callback_add(grass_mowed_check, "changed", grass_mowed_check_fun, NULL);    

   // the slider for the grass_hill_fraction from makeSineGrass
   grass_hill_fraction_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(grass_hill_fraction_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(grass_hill_fraction_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(grass_hill_fraction_slider, "%1.2f hill frac");
   elm_slider_indicator_show_set(grass_hill_fraction_slider, EINA_FALSE);
   elm_slider_min_max_set(grass_hill_fraction_slider, 0.0, 1.0);
   elm_slider_value_set(grass_hill_fraction_slider, sine_grass_get_grass_hill_fraction());
   elm_slider_span_size_set(grass_hill_fraction_slider, 200);
   evas_object_smart_callback_add(grass_hill_fraction_slider, "delay,changed", grass_hill_fraction_slider_fun, NULL);    

   box_check = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(box_check, EINA_TRUE);

   sg_check_0 = elm_check_add(win);
   elm_check_state_set(sg_check_0, EINA_FALSE);
   elm_object_part_text_set(sg_check_0, NULL, "1");
   evas_object_smart_callback_add(sg_check_0, "changed", sg_check_0_fun, &sg_check_0_indicator);
   sg_check_objs[0] = sg_check_0;

   sg_check_1 = elm_check_add(win);
   elm_check_state_set(sg_check_1, EINA_FALSE);
   elm_object_part_text_set(sg_check_1, NULL, "2");
   evas_object_smart_callback_add(sg_check_1, "changed", sg_check_0_fun, &sg_check_1_indicator);    
   sg_check_objs[1] = sg_check_1;

   sg_check_2 = elm_check_add(win);
   elm_check_state_set(sg_check_2, EINA_FALSE);
   elm_object_part_text_set(sg_check_2, NULL, "4");
   evas_object_smart_callback_add(sg_check_2, "changed", sg_check_0_fun, &sg_check_2_indicator);    
   sg_check_objs[2] = sg_check_2;

   sg_check_3 = elm_check_add(win);
   elm_check_state_set(sg_check_3, EINA_FALSE);
   elm_object_part_text_set(sg_check_3, NULL, "8");
   evas_object_smart_callback_add(sg_check_3, "changed", sg_check_0_fun, &sg_check_3_indicator);    
   sg_check_objs[3] = sg_check_3;

   sg_check_4 = elm_check_add(win);
   elm_check_state_set(sg_check_4, EINA_FALSE);
   elm_object_part_text_set(sg_check_4, NULL, "16");
   evas_object_smart_callback_add(sg_check_4, "changed", sg_check_0_fun, &sg_check_4_indicator);    
   sg_check_objs[4] = sg_check_4;

   sg_check_5 = elm_check_add(win);
   elm_check_state_set(sg_check_5, EINA_FALSE);
   elm_object_part_text_set(sg_check_5, NULL, "32");
   evas_object_smart_callback_add(sg_check_5, "changed", sg_check_0_fun, &sg_check_5_indicator);    
   sg_check_objs[5] = sg_check_5;

   sg_check_6 = elm_check_add(win);
   elm_check_state_set(sg_check_6, EINA_FALSE);
   elm_object_part_text_set(sg_check_6, NULL, "64");
   evas_object_smart_callback_add(sg_check_6, "changed", sg_check_0_fun, &sg_check_6_indicator);    
   sg_check_objs[6] = sg_check_6;

   sg_check_7 = elm_check_add(win);
   elm_check_state_set(sg_check_7, EINA_FALSE);
   elm_object_part_text_set(sg_check_7, NULL, "128");
   evas_object_smart_callback_add(sg_check_7, "changed", sg_check_0_fun, &sg_check_7_indicator);    
   sg_check_objs[7] = sg_check_7;

   box_radio = elm_box_add(win);
   //evas_object_size_hint_weight_set(box2, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   //evas_object_size_hint_align_set(box2, EVAS_HINT_FILL, EVAS_HINT_FILL);
   //elm_box_align_set(box2, 0.5, 0.0);
   elm_box_horizontal_set(box_radio, EINA_TRUE);

   sg_radio_0 = elm_radio_add(win);
   elm_radio_state_value_set(sg_radio_0, 0);
   elm_object_part_text_set(sg_radio_0, NULL, "Free");
   evas_object_smart_callback_add(sg_radio_0, "changed", sg_radio_fun, NULL);    

   sg_radio_1 = elm_radio_add(win);
   elm_radio_state_value_set(sg_radio_1, 1);
   elm_radio_group_add(sg_radio_1, sg_radio_0);
   elm_object_part_text_set(sg_radio_1, NULL, "Solo");
   evas_object_smart_callback_add(sg_radio_1, "changed", sg_radio_fun, NULL);    

   sg_radio_2 = elm_radio_add(win);
   elm_radio_state_value_set(sg_radio_2, 2);
   elm_radio_group_add(sg_radio_2, sg_radio_0);
   elm_object_part_text_set(sg_radio_2, NULL, "Above");
   evas_object_smart_callback_add(sg_radio_2, "changed", sg_radio_fun, NULL);    

   sg_radio_3 = elm_radio_add(win);
   elm_radio_state_value_set(sg_radio_3, 3);
   elm_radio_group_add(sg_radio_3, sg_radio_0);
   elm_object_part_text_set(sg_radio_3, NULL, "Below");
   evas_object_smart_callback_add(sg_radio_3, "changed", sg_radio_fun, NULL);    



   // the slider for the glawn_length_variation_frac from makeSineGrass
   lawn_length_variation_frac_slider = elm_slider_add(win);
   evas_object_size_hint_align_set(lawn_length_variation_frac_slider, EVAS_HINT_FILL, 0.5);
   evas_object_size_hint_weight_set(lawn_length_variation_frac_slider, EVAS_HINT_EXPAND, EVAS_HINT_EXPAND);
   elm_slider_unit_format_set(lawn_length_variation_frac_slider, "%1.2f var frac");
   elm_slider_indicator_show_set(lawn_length_variation_frac_slider, EINA_FALSE);
   elm_slider_min_max_set(lawn_length_variation_frac_slider, 0.0, 1.0);
   elm_slider_value_set(lawn_length_variation_frac_slider, sine_grass_get_lawn_length_variation_frac());
   elm_slider_span_size_set(lawn_length_variation_frac_slider, 200);
   evas_object_smart_callback_add(lawn_length_variation_frac_slider, "delay,changed", lawn_length_variation_frac_slider_fun, NULL);    

}


static void sine_grass_freq_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis sine_grass_freq_slider_fun\n");
   float val = (float) elm_slider_value_get(obj);
   sine_grass_params_sine_grass_freq_set(val);
   fprintf(stdout, "SG_FREQ %f\n", sine_grass_params_sine_grass_freq_get());

}

static void grass_mowed_check_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis grass_mowed_check_fun\n");
   int val = elm_check_state_get(obj);
   sine_grass_set_grass_mowed(val);
   fprintf(stdout, "GRASS_MOWED %i\n", sine_grass_get_grass_mowed());

}

static void grass_hill_fraction_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis grass_hill_fraction_slider_fun\n");
   float val = (float) elm_slider_value_get(obj);
   sine_grass_set_grass_hill_fraction(val);
   fprintf(stdout, "GRASS_HILL_FRACTION %f\n", sine_grass_get_grass_hill_fraction());

}

static void lawn_length_variation_frac_slider_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis lawn_length_variation_frac_slider_fun\n");
   float val = (float) elm_slider_value_get(obj);
   fprintf(stdout, "LLVFa = %f\n", val);
   sine_grass_set_lawn_length_variation_frac(val);
   fprintf(stdout, "LLVF = %f\n", sine_grass_get_lawn_length_variation_frac());
   fprintf(stdout, "LLVFc = %f\n", val);
   int val2 = (int) trunc(sine_grass_params_lawn_length_get()*sine_grass_get_lawn_length_variation_frac()); 
   sine_grass_params_lawn_length_variation_max_set(val2);
   fprintf(stdout, "GRASS_HILL_FRACTION %i/%i\n", sine_grass_params_lawn_length_variation_max_get(), sine_grass_params_lawn_length_get());

}


static void sg_check_set_var_frac(){

   
   float val = (float) sg_check_combined_state/255.0;
   sine_grass_set_lawn_length_variation_frac(val);

   int val2 = (int) trunc(sine_grass_params_lawn_length_get()*sine_grass_get_lawn_length_variation_frac()); 
   sine_grass_params_lawn_length_variation_max_set(val2);

   elm_slider_value_set(lawn_length_variation_frac_slider, sine_grass_get_lawn_length_variation_frac());
   fprintf(stdout, "GRASS_HILL_FRACTION %i/%i\n", sine_grass_params_lawn_length_variation_max_get(), sine_grass_params_lawn_length_get());

}

static void sg_check_0_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis sg_check_0_fun\n");
   sg_check_0_state = elm_check_state_get(obj);
   int indicator = *((int *) data);
   int add_amount = 1;
   if(indicator){
      add_amount = add_amount << indicator;
   }

   switch(sg_radio_val){

      case 0: {
                 if(sg_check_0_state){
                    sg_check_combined_state += add_amount;
                 }else{
                    sg_check_combined_state -= add_amount;
                 }
                 break;
              }

      case 1: {
                 sg_check_combined_state = add_amount;
                 int i;
                 for(i = 0; i < 8; ++i){
                    elm_check_state_set(sg_check_objs[i], EINA_FALSE);
                 }
                 elm_check_state_set(sg_check_objs[indicator], EINA_TRUE);
                 break;

              }
      case 2: {
                 int i;
                 add_amount = 1;
                 sg_check_combined_state = 0;
                 for(i = 0; i < 8; ++i){
                    add_amount = add_amount << (1 && i);
                    //fprintf(stdout, "Schnipschnipp %i\n", add_amount);
                    if(i >= indicator){
                       sg_check_combined_state += add_amount;
                       elm_check_state_set(sg_check_objs[i], EINA_TRUE);
                    }else{
                       elm_check_state_set(sg_check_objs[i], EINA_FALSE);
                    }
                 }
                 break;

              }
      case 3: {
                 int i;
                 add_amount = 1;
                 sg_check_combined_state = 0;
                 for(i = 0; i < 8; ++i){
                    add_amount = add_amount << (1 && i);
                    //fprintf(stdout, "Schnipschnipp %i\n", add_amount);
                    if(i <= indicator){
                       sg_check_combined_state += add_amount;
                       elm_check_state_set(sg_check_objs[i], EINA_TRUE);
                    }else{
                       elm_check_state_set(sg_check_objs[i], EINA_FALSE);
                    }
                 }
                 break;

              }
   }
   sg_check_set_var_frac();
   fprintf(stdout, "1 State %i Ind %i Combined %i\n", sg_check_0_state, indicator, sg_check_combined_state);

}
   
static void sg_radio_fun(void *data, Evas_Object *obj, void *event_info){

   fprintf(stdout, "Yis sg_radio_fun\n");
   sg_radio_val = elm_radio_value_get(obj);
   fprintf(stdout, "sg_radio_val = %i\n", sg_radio_val);

}

void sine_grass_freq_slider_set(const float value)
{

        elm_slider_value_set(sine_grass_freq_slider, (double) value);
   
}

void sine_grass_grass_mowed_check_set(const int value){

        if(value == 0){
                elm_check_state_set(grass_mowed_check, EINA_FALSE);
        }else{
                elm_check_state_set(grass_mowed_check, EINA_TRUE);
        }

}
void sine_grass_grass_hill_fraction_slider_set(const float value){

        elm_slider_value_set(grass_hill_fraction_slider, (double) value);

}
void sine_grass_lawn_length_variation_frac_slider_set(const float value){

        elm_slider_value_set(lawn_length_variation_frac_slider, (double) value);

}
void sine_grass_gui_set_self_control(const int value)
{
    sine_grass_set_self_control(value);
    if(sine_grass_get_self_control()){
       elm_object_disabled_set(sine_grass_freq_slider, EINA_FALSE);
    }else{
       elm_object_disabled_set(sine_grass_freq_slider, EINA_TRUE);
    }

}

