// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESCWYP_SINE_GRASS_PARAMS_H
#define ESCWYP_SINE_GRASS_PARAMS_H

struct sine_grass_params{

   float sine_grass_freq;// = 100.8;
   // the kind of period value for makeSineGrass. Remebers the number of samples completed.
   // Is checked in makeSineGrass to alter sign and value of the calculated samples.
   int grass_sign_count;// = 0;
   // the sign of the samples
   int grass_sign;// = 1;
   // these are the length of one piece of lawn or one hill, and the index of the middle of the hill or lawn
   int lawn_length;// = 1;
   int lawn_hill_index;// = 0; 
   // the random-value for the hill-top
   float grass_rnd;// = 0.0;
   int lawn_length_variation_max;// = 0;
   int lawn_length_variation;// = 0;
};


#endif
