// Copyright 2014-2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESCWYP_SPRATZ_EXTERN_H
#define ESCWYP_SPRATZ_EXTERN_H
#include "escwyp_spratz_params.h"

void spratz_default_params(struct spratz_params *the_params);
void print_params_spratz(struct spratz_params *the_params);

void spratz_refresh_parameters();
void spratz_set_params(struct spratz_params *params);
void spratz_set_freq(const float freq);
void spratz_set_freq_from_klavier(const float freq, const float freq_low, const float freq_high);
void spratz_init_values();

void spratz_set_x_fact(const float the_fact);
void spratz_set_y_fact(const float the_fact);
void spratz_set_depth(const int value);
void spratz_set_samplerate(const float value);

float spratz_get_x_fact();
float spratz_get_y_fact();
int spratz_get_depth();
float spratz_get_samplerate();

void spratz_constructor();
void makeSpratz(const int length, float *buff_L);
void spratz_set_self_control(const int value);
int spratz_get_self_control();


#endif
