// Copyright 2015, Jean Rene Dawin
//
// This Library is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 2.1 of the License, or
// (at your option) any later version.
//
// This Library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this Library.  If not, see <http://www.gnu.org/licenses/>.

#include "escwyp_utils.h"
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

void escwyp_gen_random_string(char *patch_name, int opt){

	char ziffern[10];
	char kleinbu[26];
	char grossbu[26];
	char vokale[5];
	char konsonanten[21];

	int i;
	int j = 0;
	int k = 0;
	for(i = 0; i < 10; ++i){
		ziffern[i] = 48+i;
	}
	for(i = 0; i < 26; ++i){
		kleinbu[i] = 97+i;
		if(i == 0 || i == 4 || i == 8 || i == 14 || i == 20){
			vokale[j++] = 97+i;
		}else{
			konsonanten[k++] = 97+i;
		}
	}
	for(i = 0; i < 26; ++i){
		grossbu[i] = 65+i;
	}

	switch(opt){
		case 0: {

				for(i = 0; i < 10; ++i){
					float teiler = (float) random()/RAND_MAX;
					if(teiler <= 10.0/62.0){
						float rnd = (float) 9*random()/RAND_MAX;
						int rnd_i = (int) trunc(rnd);
						patch_name[i] = ziffern[rnd_i];
					}
					if(teiler > 10.0/62.0 && teiler <= 36.0/62.0){
						float rnd = (float) 25*random()/RAND_MAX;
						int rnd_i = (int) trunc(rnd);
						patch_name[i] = kleinbu[rnd_i];
					}
					if(teiler > 36.0/62.0 && teiler <= 1.0){
						float rnd = (float) 25*random()/RAND_MAX;
						int rnd_i = (int) trunc(rnd);
						patch_name[i] = grossbu[rnd_i];
					}
				}
				patch_name[10] = 0;
			}
			break;       
		case 1: {
				int vok_count = 0;
				int kons_count = 0;
				for(i = 0; i < 7; ++i){
					float rnd_vk = (float) random()/RAND_MAX;
					if(vok_count > 2){
						rnd_vk = 0.75;
						vok_count = 0;
					}
					if(kons_count > 1){
						rnd_vk = 0.25;
						kons_count = 0;
					}
					if(rnd_vk < 0.5){
						kons_count = 0;
						float rnd = (float) 4*random()/RAND_MAX;
						int rnd_i = (int) trunc(rnd);
						if(i){
							patch_name[i] = vokale[rnd_i];
						}else{
							patch_name[i] = vokale[rnd_i]-32;
						}
						++vok_count;
					}else{
						vok_count = 0;
						float rnd = (float) 20*random()/RAND_MAX;
						int rnd_i = (int) trunc(rnd);
						if(i){
							patch_name[i] = konsonanten[rnd_i];
						}else{
							patch_name[i] = konsonanten[rnd_i]-32;
						}
						++kons_count;
					}
				}
				patch_name[7] = 0;
			}
			break;
	}
	fprintf(stdout, "THE PATCH_-SYLB- NAME = %s\n", patch_name);


}

